/*-------------------------------------
| SAVVY Organizer                     |
| Rev. 2.3 / 28.04.2020               |
---------------------------------------
*/

// --- general variables
var Organizer = document.Organizer;
var HexChrs = "0123456789ABCDEF";
var ErrorCheck = 9;
var ErrorName = "";
var DevID = "";
var AuxVar0, AuxVar1;
var NameXOffset, AuxChrA, AuxChrB, GenMsg;

var IndexTab = new Array;
IndexTab[0] = new Array("???", "???", "???", "???");
IndexTab[1] = new Array("Roland", "Juno-106, HS-60", "001", "2.0", "00120");
IndexTab[2] = new Array("Roland", "Alpha Juno 1/2, HS-10, HS-80", "002", "2.0", "00220");
IndexTab[3] = new Array("Roland", "JX-8P", "003", "2.0", "00320");
IndexTab[4] = new Array("Roland", "MKS-50", "004", "2.0", "00420");
IndexTab[5] = new Array("Roland", "JX-10, MKS-70 - Super JX (V4 PWM)", "005", "2.0", "00520");
IndexTab[6] = new Array("Roland", "MKS-80 Super Jupiter", "006", "2.0", "00620");
IndexTab[7] = new Array("Kawai", "K3, K3M", "007", "2.0", "00720");
IndexTab[8] = new Array("Yamaha", "DX21, DX27, DX27S, DX100", "008", "2.0", "00820");
IndexTab[9] = new Array("Yamaha", "V50", "009", "2.0", "00920");
IndexTab[10] = new Array("Yamaha", "DX11, TX81Z", "010", "2.0", "01020");
IndexTab[11] = new Array("Yamaha", "B200, TQ5, YS100, YS200", "011", "2.0", "01120");
IndexTab[12] = new Array("Yamaha", "DS55", "012", "2.0", "01220");

var ErrTab = new Array;
ErrTab[0] = "Data OK";
ErrTab[1] = "Incomplete data (too short)";
ErrTab[2] = "Another device (instrument) data";
ErrTab[3] = "Invalid Device ID";
ErrTab[4] = "Faulty header of ";
ErrTab[5] = "Invalid databyte inside ";
ErrTab[6] = "Faulty checksum of ";
ErrTab[7] = "Missing EOX of ";
ErrTab[8] = "err 8";
ErrTab[9] = "None data";

// --- functions

function CheckData() {
	var i, j;
	ErrorCheck = 0;
	ErrorName = "";
	document.Organizer.wholemsg.value = (document.Organizer.wholemsg.value).toUpperCase();
	GenMsg = (document.Organizer.wholemsg.value);
	i = 0;
	while (i <= GenMsg.length) {
		while (GenMsg.substr(i, 1) == " ") {
			GenMsg = GenMsg.substr(0, i) + GenMsg.substr(i+1, GenMsg.length - (i+1));
		}
		++i;
		while (GenMsg.substr(i, 1) == " ") {
			GenMsg = GenMsg.substr(0, i) + GenMsg.substr(i+1, GenMsg.length - (i+1));
		}
		++i;
		if (GenMsg.substr(i, 1) != " ") {
			GenMsg = GenMsg.substr(0, i) + " " + GenMsg.substr(i, GenMsg.length - i);
		}
		++i;
	}
	document.Organizer.wholemsg.value = GenMsg;
	if (((document.Organizer.wholemsg.value).length) == 0) {
		ErrorCheck = 9;
		ErrorName = "";
	} else if (((document.Organizer.wholemsg.value).length) < MsgChrs-1) {
		ErrorCheck = 1;
		ErrorName = "";
	} else {
		document.Organizer.wholemsg.value = (document.Organizer.wholemsg.value).substr(0, MsgChrs);

	}
	if (ErrorCheck == 0) {
		AuxChrB = HexChrs.charAt(Math.floor(InstrOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(InstrOS % 16));
		AuxChrB += " ";
		AuxChrB += HexChrs.charAt(Math.floor(VerOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(VerOS % 16));
		if ((document.Organizer.wholemsg.value).substr(21, 5) != AuxChrB) {
			ErrorCheck = 2;
			ErrorName = "";
		}

	}
	if (ErrorCheck == 0) {
		AuxChrA = (document.Organizer.wholemsg.value).substr(12, 2);
		AuxVar0 = parseInt(AuxChrA, 16);
		if ((AuxVar0 > 15) && (AuxVar0 != 127)) {
			ErrorCheck = 3;
			ErrorName = "";
		} else {
			DevID = AuxChrA;
		}
	}
	AuxChrA = "F0 00 20 21 " + DevID + " 41 ";
	if (ErrorCheck == 0) {
		AuxChrB = AuxChrA+"10 ";
		AuxChrB += HexChrs.charAt(Math.floor(InstrOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(InstrOS % 16));
		AuxChrB += " ";
		AuxChrB += HexChrs.charAt(Math.floor(VerOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(VerOS % 16));
		if ((document.Organizer.wholemsg.value).substr(0, 26) != AuxChrB) {
			ErrorCheck = 4;
			ErrorName = "Global data";

		}
	}
	if (ErrorCheck == 0) {
		AuxChrB = AuxChrA+"20 ";
		AuxChrB += HexChrs.charAt(Math.floor(InstrOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(InstrOS % 16));
		AuxChrB += " ";
		AuxChrB += HexChrs.charAt(Math.floor(VerOS / 16));
		AuxChrB += HexChrs.charAt(Math.floor(VerOS % 16));
		if ((document.Organizer.wholemsg.value).substr(69, 26) != AuxChrB) {
			ErrorCheck = 4;
			ErrorName = "Instrument data";
		}
	}
	if (ErrorCheck == 0) {
		AuxChrA = AuxChrA + "30 ";
		AuxChrA += HexChrs.charAt(Math.floor(InstrOS / 16));
		AuxChrA += HexChrs.charAt(Math.floor(InstrOS % 16));
		AuxChrA += " ";
		AuxChrA += HexChrs.charAt(Math.floor(VerOS / 16));
		AuxChrA += HexChrs.charAt(Math.floor(VerOS % 16));
		for (i=0; i<=TonesNr; ++i) {
			AuxChrB = AuxChrA + " 0" + HexChrs.charAt(Math.floor(i / 128)) + " ";
			AuxChrB += HexChrs.charAt(Math.floor(Math.floor(i % 128) / 16));
			AuxChrB += HexChrs.charAt(Math.floor(i % 16));
			AuxVar0 = ToneOffset + i * ToneLength;
			if ((document.Organizer.wholemsg.value).substr(AuxVar0, 32) != AuxChrB) {
				ErrorCheck = 4;
				i ++;
				ErrorName = "Tone Nr. " + i;
				i = TonesNr;
			}
		}
	}
	if (ErrorCheck == 0) {
		AuxVar0 = 0;
		j = 15;
		while (j < 63) {
			AuxChrA = (document.Organizer.wholemsg.value).substr(j, 2);
			AuxVar1 = parseInt(AuxChrA, 16);
			if (AuxVar1 > 127) {
				ErrorCheck =5;
				ErrorName = "Global data";
				j = 63;
			} else {
				AuxVar0 += AuxVar1
				j += 3;
			}
		}
		if (ErrorCheck == 0) {
			AuxVar0 = (128 - (AuxVar0 % 128)) % 128;
			AuxChrB = HexChrs.charAt(Math.floor(AuxVar0 / 16));
			AuxChrB += HexChrs.charAt(Math.floor(AuxVar0 % 16));
			if ((document.Organizer.wholemsg.value).substr(63, 2) != AuxChrB) {
				ErrorCheck =6;
				ErrorName = "Global data";
			} 
		}
	}
	if (ErrorCheck == 0) {
		AuxVar0 = 0;
		j = 84;
		while (j < (ToneOffset - 6)) {
			AuxChrA = (document.Organizer.wholemsg.value).substr(j, 2);
			AuxVar1 = parseInt(AuxChrA, 16);
			if (AuxVar1 > 127) {
				ErrorCheck =5;
				ErrorName = "Instrument data";
				j = (ToneOffset - 6);
			} else {
				AuxVar0 += AuxVar1
				j += 3;
			}
		}
		if (ErrorCheck == 0) {
			AuxVar0 = (128 - (AuxVar0 % 128)) % 128;
			AuxChrB = HexChrs.charAt(Math.floor(AuxVar0 / 16));
			AuxChrB += HexChrs.charAt(Math.floor(AuxVar0 % 16));
			if ((document.Organizer.wholemsg.value).substr((ToneOffset - 6), 2) != AuxChrB) {
				ErrorCheck =6;
				ErrorName = "Instrument data";
			}
		}
	}
	if (ErrorCheck == 0) {
		for (i=0; i<=TonesNr; ++i) {
			AuxVar0 = 0;
			j = (15+ToneOffset+i*ToneLength);
			while (j < (ToneOffset+i*ToneLength+(ToneLength-6))) {
				AuxChrA = (document.Organizer.wholemsg.value).substr(j, 2);
				AuxVar1 = parseInt(AuxChrA, 16);
				if (AuxVar1 > 127) {
					ErrorCheck =5;
					i ++;
					ErrorName = "Tone Nr. " + i;
					i = TonesNr;
					j = (ToneOffset+i*ToneLength+(ToneLength-6));

				} else {
					AuxVar0 += AuxVar1
					j += 3;
				}
			}
			if (ErrorCheck == 0) {
				AuxVar0 = (128 - (AuxVar0 % 128)) % 128;
				AuxChrB = HexChrs.charAt(Math.floor(AuxVar0 / 16));
				AuxChrB += HexChrs.charAt(Math.floor(AuxVar0 % 16));
				if ((document.Organizer.wholemsg.value).substr((ToneOffset+i*ToneLength+(ToneLength-6)), 2) != AuxChrB) {
					ErrorCheck = 6;
					i ++;
					ErrorName = "Tone Nr. " + i;
					i = TonesNr;
				}
			}
		}
	}
	if (ErrorCheck == 0) {
		if ((document.Organizer.wholemsg.value).substr(66, 2) != "F7") {
			ErrorCheck = 7;
			ErrorName = "Global data";
		}
	}
	if (ErrorCheck == 0) {
		if ((document.Organizer.wholemsg.value).substr((ToneOffset - 3), 2) != "F7") {
			ErrorCheck =7;
			ErrorName = "Instrument data";
		}
	}
	if (ErrorCheck == 0) {
		for (i=0; i<=TonesNr; ++i) {
			if ((document.Organizer.wholemsg.value).substr((ToneOffset + (i+1)*ToneLength - 3), 2) != "F7") {
				ErrorCheck =7;
				i ++;
				ErrorName = "Tone Nr. " + i;
				i = TonesNr;
			}
		}
	}
	document.Organizer.statuscheck.value = ErrTab[ErrorCheck] + ErrorName;
	if (ErrorCheck > 0) {
		DevID = "";
		document.Organizer.statusid.value = "";
		document.Organizer.namein.value = "";
		document.Organizer.syxin.value = "";
        	document.Organizer.syxout.value = "";
	} else {
		document.Organizer.statusid.value = DevID;
		CalcIn()
		CalcOut()
		ChngView()
	}
}

function InDec() {
	AuxVar0 = (document.Organizer.tonein.value);
	if (AuxVar0 > 0) {
		-- AuxVar0;
	} else {
		AuxVar0 = TonesNr;
	}
	document.Organizer.tonein.value = AuxVar0;
	GetIn()
}

function InInc() {
	AuxVar0 = (document.Organizer.tonein.value);
	if (AuxVar0 < TonesNr) {
		++ AuxVar0;
	} else {
		AuxVar0 = 0;
	}
	document.Organizer.tonein.value = AuxVar0;
	GetIn()
}

function GetIn() {
	document.Organizer.bankin.value = (Math.floor((document.Organizer.tonein.value)/128));
	document.Organizer.pgmin.value = (Math.floor((document.Organizer.tonein.value)%128));
	if (ErrorCheck > 0) {
		alert("Invalid data on input! Insert correct SysEx messages!");
	} else {
		CalcIn()
		CalcOut()
	}
}

function CalcIn() {
	if (ErrorCheck > 0) {
		alert("Invalid data on input! Insert correct SysEx messages!");
	} else {
		NameXOffset = (document.Organizer.tonein.value) * ToneLength + ToneOffset;
		AuxVar0, AuxVar1 = "";
		ExtractName()
		document.Organizer.namein.value = AuxVar1;
		document.Organizer.syxin.value = (document.Organizer.wholemsg.value).substr(NameXOffset, (ToneLength-1));
	}
}

function OutDec() {
	AuxVar0 = (document.Organizer.toneout.value);
	if (AuxVar0 > 0) {
		-- AuxVar0;
	} else {
		AuxVar0 = TonesNr;
	}
	document.Organizer.toneout.value = AuxVar0;
	GetOut()
}

function OutInc() {
	AuxVar0 = (document.Organizer.toneout.value);
	if (AuxVar0 < TonesNr) {
		++ AuxVar0;
	} else {
		AuxVar0 = 0;
	}
	document.Organizer.toneout.value = AuxVar0;
	GetOut()
}

function GetOut() {
        document.Organizer.bankout.value = (Math.floor((document.Organizer.toneout.value)/128));
        document.Organizer.pgmout.value = (Math.floor((document.Organizer.toneout.value)%128));
	if (ErrorCheck == 0) {
		CalcOut();
	}
}

function CalcOut() {
	if (ErrorCheck > 0) {
		alert("Invalid data on input! Insert correct SysEx messages!");
	} else {
		var ChSum, AuxByte, i;
		GenMsg = (document.Organizer.syxin.value).substr(0, 27);
		GenMsg += "0";
		GenMsg += HexChrs.charAt(document.Organizer.bankout.value);
		GenMsg += " ";
		GenMsg += HexChrs.charAt(Math.floor(document.Organizer.pgmout.value / 16));
		GenMsg += HexChrs.charAt(Math.floor(document.Organizer.pgmout.value % 16));
		GenMsg += " ";
		ChSum = 113;
		ChSum += parseInt((document.Organizer.syxin.value).substr(21, 2), 16);
		ChSum += parseInt((document.Organizer.syxin.value).substr(24, 2), 16);
		ChSum += 1*document.Organizer.bankout.value;
		ChSum += 1*document.Organizer.pgmout.value;
		i = 33;
		while (i < NameOffset)
		{
			AuxByte = (document.Organizer.syxin.value).substr(i, 2);
			GenMsg += AuxByte;
			GenMsg += " ";
			ChSum += parseInt(AuxByte, 16);
			i +=3;
		}
		for (i=0; i<NameLength; ++i) {
			AuxByte = (document.Organizer.nameout.value).charCodeAt(i);
			if ((InstrOS == 2)||(InstrOS == 4)) {
				AuxByte = TabChrs[AuxByte];
			}
			ChSum += AuxByte;
			GenMsg += HexChrs.charAt(Math.floor(AuxByte / 16));
			GenMsg += HexChrs.charAt(Math.floor(AuxByte % 16));
			GenMsg += " ";
		}
		i = (NameOffset + 3*NameLength)
		while (i < (ToneLength-6)) {
			AuxByte = (document.Organizer.syxin.value).substr(i, 2);
			GenMsg += AuxByte;
			GenMsg += " ";
			ChSum += parseInt(AuxByte, 16);
			i +=3;
		}
		ChSum = (128 - (ChSum % 128)) % 128;
		GenMsg += HexChrs.charAt(Math.floor(ChSum / 16));
		GenMsg += HexChrs.charAt(Math.floor(ChSum % 16));
		GenMsg += " F7";
	        document.Organizer.syxout.value = GenMsg;
	}
}

function ChangeName() {
	var AuxByte, AuxName, i;
	AuxByte = (document.Organizer.nameout.value).length;
	if (AuxByte < NameLength) {
		for (i=AuxByte; i<NameLength; ++i) {
			document.Organizer.nameout.value = document.Organizer.nameout.value + " ";
		}
	AuxByte = NameLength;
	}
	if (AuxByte > NameLength) {
		document.Organizer.nameout.value = (document.Organizer.nameout.value).substr(0, NameLength);
	}
	AuxName = ""
	for (i=0; i<NameLength; ++i) {
		AuxByte = (document.Organizer.nameout.value).charCodeAt(i);
		if ((InstrOS == 2)||(InstrOS == 4)) {
			if ((AuxByte==32)||(AuxByte==45)||((AuxByte>47)&&(AuxByte<58))||((AuxByte>64)&&(AuxByte<91))||((AuxByte>96)&&(AuxByte<123))) {
				AuxName += (document.Organizer.nameout.value).substr(i, 1);
			} else {
				AuxName += " ";
			}
		} else if ((InstrOS == 3)||(InstrOS == 5)) {
			if ((AuxByte==32)||(AuxByte==42)||((AuxByte>44)&&(AuxByte<58))||((AuxByte>64)&&(AuxByte<91))||(AuxByte==92)) {
				AuxName += (document.Organizer.nameout.value).substr(i, 1);
			} else if ((AuxByte > 96)&&(AuxByte < 123)) {
				AuxName += (document.Organizer.nameout.value).substr(i, 1).toUpperCase();
			} else {
				AuxName += " ";
			}
		} else {
			if ((AuxByte>31)&&(AuxByte<128)) {
				AuxName += (document.Organizer.nameout.value).substr(i, 1);
			} else {
				AuxName += " ";
			}
		}
	}
	document.Organizer.nameout.value = AuxName;
	if (ErrorCheck == 0) {
		CalcOut();
	}
}

function CopyName() {
	if (ErrorCheck > 0) {
		alert("None name on input!");
	} else {
		document.Organizer.nameout.value = document.Organizer.namein.value;
		CalcOut();
	}
}

function SaveOut() {
	if (ErrorCheck > 0) {
		alert("None data for saving!");
	} else {
		GenMsg = "";
		AuxVar0 = (document.Organizer.toneout.value) * ToneLength + ToneOffset;
		GenMsg = (document.Organizer.wholemsg.value).substr(0, AuxVar0);
		GenMsg += document.Organizer.syxout.value;
		GenMsg += " ";
		AuxVar0 += ToneLength;
		AuxVar1 = (MsgChrs - AuxVar0);
		GenMsg += (document.Organizer.wholemsg.value).substr(AuxVar0, AuxVar1);
		document.Organizer.wholemsg.value = GenMsg;
		document.Organizer.statuscheck.value = "Tone "+(1*(document.Organizer.toneout.value)+1)+" changed!";
		if (document.Organizer.tonein.value == document.Organizer.toneout.value) {
			document.Organizer.namein.value = document.Organizer.nameout.value;
			document.Organizer.syxin.value = document.Organizer.syxout.value;
		}
		ChngView()
	}
}

function ChngView() {
	var i, j, k, ToneView;
	var TabCls0 = (Math.floor(TonesNr / 128));
	for (i=0; i<=TabCls0; ++i) {
		ToneView = "";
		for (j=0; j<128; ++j) {

			NameXOffset = (128*i+j+1)+": ";
                        while (NameXOffset.length < 5) {
				NameXOffset = "0" + NameXOffset;
			}
			ToneView += NameXOffset;
			NameXOffset = (i*128+j)*ToneLength + ToneOffset;
			AuxVar0, AuxVar1 = "";
			ExtractName()
			ToneView += AuxVar1;
			ToneView += "\n";
		}
		if (i==0) {
			document.Organizer.tonevw0.value = ToneView;
		} else if (i==1) {
			document.Organizer.tonevw1.value = ToneView;
		} else if (i==2) {
			document.Organizer.tonevw2.value = ToneView;
		} else if (i==3) {
			document.Organizer.tonevw3.value = ToneView;
		} else if (i==4) {
			document.Organizer.tonevw4.value = ToneView;
		} else if (i==5) {
			document.Organizer.tonevw5.value = ToneView;
		} else if (i==6) {
			document.Organizer.tonevw6.value = ToneView;
		}
	}
}

function ExtractName() {
	var k = (NameXOffset + NameOffset);
	while (k < (NameXOffset + NameOffset + 3*NameLength)) {
		AuxVar0 = (document.Organizer.wholemsg.value).substr(k, 2);
		AuxVar0 = parseInt(AuxVar0, 16);
		if ((InstrOS == 2)||(InstrOS == 3)||(InstrOS == 4)||(InstrOS == 5)) {
			AuxVar1 += String.fromCharCode(NameChrs[AuxVar0]);
		} else {
			AuxVar1 += String.fromCharCode(AuxVar0);
		}
		k +=3;
	}
}

function BADec() {
	AuxVar0 = (document.Organizer.bain.value);
	if (AuxVar0 > 0) {
		-- AuxVar0;
	} else {
		AuxVar0 = Math.floor(TonesNr / 128);
	}
	document.Organizer.bain.value = AuxVar0;
}

function BAInc() {
	AuxVar0 = (document.Organizer.bain.value);
	if (AuxVar0 < Math.floor(TonesNr / 128)) {
		++ AuxVar0;
	} else {
		AuxVar0 = 0;
	}
	document.Organizer.bain.value = AuxVar0;
}

function BBDec() {
	AuxVar0 = (document.Organizer.bbin.value);
	if (AuxVar0 > 0) {
		-- AuxVar0;
	} else {
		AuxVar0 = Math.floor(TonesNr / 128);
	}
	document.Organizer.bbin.value = AuxVar0;
}

function BBInc() {
	AuxVar0 = (document.Organizer.bbin.value);
	if (AuxVar0 < Math.floor(TonesNr / 128)) {
		++ AuxVar0;
	} else {
		AuxVar0 = 0;
	}
	document.Organizer.bbin.value = AuxVar0;
}

function GetBank() {
	GenMsg = "";
	var i, j, ChSum, AuxChr;
	for (i=0; i<128; ++i) {
		GenMsg += "F0 00 20 21 " + DevID + " 41 30 ";
		GenMsg += HexChrs.charAt(Math.floor(InstrOS / 16));
		GenMsg += HexChrs.charAt(Math.floor(InstrOS % 16));
		GenMsg += " ";
		GenMsg += HexChrs.charAt(Math.floor(VerOS / 16));
		GenMsg += HexChrs.charAt(Math.floor(VerOS % 16));
		GenMsg += " 0";
		GenMsg += HexChrs.charAt(AuxVar1);
		GenMsg += " ";
		GenMsg += HexChrs.charAt(Math.floor(i / 16));
		GenMsg += HexChrs.charAt(Math.floor(i % 16));
		GenMsg += " ";
		ChSum = 113 + InstrOS + VerOS + 1*AuxVar1 + i;
		AuxChr = (document.Organizer.wholemsg.value).substr((ToneOffset + (128 * AuxVar0 + i) * ToneLength + 33), (ToneLength - 39));
		GenMsg += AuxChr;
		j = 0;
		while (j < (ToneLength - 39)) {
			ChSum += parseInt(AuxChr.substr(j, 2), 16);
			j += 3; 
		}
		ChSum = (128 - (ChSum % 128)) % 128;
		GenMsg += HexChrs.charAt(Math.floor(ChSum / 16));
		GenMsg += HexChrs.charAt(Math.floor(ChSum % 16));
		GenMsg += " F7 ";
	}
}

function CopyB() {
	if (ErrorCheck > 0) {
		alert("None data for processing! Insert correct SysEx messages!");
	} else {
		if (document.Organizer.bain.value == document.Organizer.bbin.value) {
			alert("Select different numbers for Bank A and Bank B!");
		} else {
			var BConf = confirm("Are you sure?");
			if (BConf) {
				AuxVar0 = document.Organizer.bain.value;
				AuxVar1 = document.Organizer.bbin.value;
				GetBank()
				AuxVar0 = 128*document.Organizer.bbin.value * ToneLength + ToneOffset;
				GenMsg = (document.Organizer.wholemsg.value).substr(0, AuxVar0) + GenMsg;
				AuxVar0 += (128 * ToneLength);
				AuxVar1 = (MsgChrs - AuxVar0);
				GenMsg += (document.Organizer.wholemsg.value).substr(AuxVar0, AuxVar1);
				document.Organizer.wholemsg.value = GenMsg;
				GetIn()
				ChngView()
				document.Organizer.statuscheck.value = "Bank "+(document.Organizer.bbin.value)+" changed!";
			}
		}
	}
}

function ExchB() {
	if (ErrorCheck > 0) {
		alert("None data for processing! Insert correct SysEx messages!");
	} else {
		if (document.Organizer.bain.value == document.Organizer.bbin.value) {
			alert("Select different numbers for Bank A and Bank B!");
		} else {
			var BConf = confirm("Are you sure?");
			if (BConf) {
				AuxVar0 = document.Organizer.bain.value;
				AuxVar1 = document.Organizer.bbin.value;
				GetBank()
				AuxChrB = GenMsg
				AuxVar0 = document.Organizer.bbin.value;
				AuxVar1 = document.Organizer.bain.value;
				GetBank()
				AuxChrA = GenMsg
				AuxVar0 = 128*document.Organizer.bain.value * ToneLength + ToneOffset;
				GenMsg = (document.Organizer.wholemsg.value).substr(0, AuxVar0) + AuxChrA;
				AuxVar0 += (128 * ToneLength);
				AuxVar1 = (MsgChrs - AuxVar0);
				GenMsg += (document.Organizer.wholemsg.value).substr(AuxVar0, AuxVar1);
				document.Organizer.wholemsg.value = GenMsg;
				AuxVar0 = 128*document.Organizer.bbin.value * ToneLength + ToneOffset;
				GenMsg = (document.Organizer.wholemsg.value).substr(0, AuxVar0) + AuxChrB;
				AuxVar0 += (128 * ToneLength);
				AuxVar1 = (MsgChrs - AuxVar0);
				GenMsg += (document.Organizer.wholemsg.value).substr(AuxVar0, AuxVar1);
				document.Organizer.wholemsg.value = GenMsg;
				GetIn()
				ChngView()
				document.Organizer.statuscheck.value = "Banks "+(document.Organizer.bain.value)+" and "+(document.Organizer.bbin.value)+" changed!"; 			}
		}
	}
}

function InitB() {
	if (ErrorCheck > 0) {
		alert("None data for processing! Insert correct SysEx messages!");
	} else {
		var BConf = confirm("Are you sure?");
		if (BConf) {
			GenMsg = "";
			var i, ChSum;
			for (i=0; i<128; ++i) {
				GenMsg += "F0 00 20 21 " + DevID + " 41 30 ";
				GenMsg += HexChrs.charAt(Math.floor(InstrOS / 16));
				GenMsg += HexChrs.charAt(Math.floor(InstrOS % 16));
				GenMsg += " ";
				GenMsg += HexChrs.charAt(Math.floor(VerOS / 16));
				GenMsg += HexChrs.charAt(Math.floor(VerOS % 16));
				GenMsg += " 0";
				GenMsg += HexChrs.charAt(document.Organizer.bain.value);
				GenMsg += " ";
				GenMsg += HexChrs.charAt(Math.floor(i / 16));
				GenMsg += HexChrs.charAt(Math.floor(i % 16));
				GenMsg += " ";
				ChSum = 113 + InstrOS + VerOS + 1*(document.Organizer.bain.value) + i;
				GenMsg += DataIni;
				j = 0;
				while (j < (ToneLength - 39)) {
					ChSum += parseInt(DataIni.substr(j, 2), 16);
					j += 3; 
				}
				ChSum = (128 - (ChSum % 128)) % 128;
				GenMsg += HexChrs.charAt(Math.floor(ChSum / 16));
				GenMsg += HexChrs.charAt(Math.floor(ChSum % 16));
				GenMsg += " F7 ";
			}
			AuxVar0 = 128*document.Organizer.bain.value * ToneLength + ToneOffset;
			GenMsg = (document.Organizer.wholemsg.value).substr(0, AuxVar0) + GenMsg;
			AuxVar0 += (128 * ToneLength);
			AuxVar1 = (MsgChrs - AuxVar0);
			GenMsg += (document.Organizer.wholemsg.value).substr(AuxVar0, AuxVar1);
			document.Organizer.wholemsg.value = GenMsg;
			GetIn()
			ChngView()
			document.Organizer.statuscheck.value = "Bank "+(document.Organizer.bain.value)+" changed!";
		}
	}
}

function InitOut() {
	if (ErrorCheck > 0) {
		alert("None data on input!");
	} else {
		var ChSum, j;
		GenMsg = "F0 00 20 21 " + DevID + " 41 30 ";
		GenMsg += HexChrs.charAt(Math.floor(InstrOS / 16));
		GenMsg += HexChrs.charAt(Math.floor(InstrOS % 16));
		GenMsg += " ";
		GenMsg += HexChrs.charAt(Math.floor(VerOS / 16));
		GenMsg += HexChrs.charAt(Math.floor(VerOS % 16));
		GenMsg += " 0";
		GenMsg += HexChrs.charAt(document.Organizer.bankout.value);
		GenMsg += " ";
		GenMsg += HexChrs.charAt(Math.floor(document.Organizer.pgmout.value / 16));
		GenMsg += HexChrs.charAt(Math.floor(document.Organizer.pgmout.value % 16));
		GenMsg += " ";
		ChSum = 113 + InstrOS + VerOS + 1*(document.Organizer.bankout.value) + 1*(document.Organizer.pgmout.value);
		GenMsg += DataIni;
		j = 0;
		while (j < (ToneLength - 39)) {
			ChSum += parseInt(DataIni.substr(j, 2), 16);
			j += 3; 
		}
		ChSum = (128 - (ChSum % 128)) % 128;
		GenMsg += HexChrs.charAt(Math.floor(ChSum / 16));
		GenMsg += HexChrs.charAt(Math.floor(ChSum % 16));
		GenMsg += " F7";
		document.Organizer.syxout.value = GenMsg;
                var AuxName = "";
		var k = NameOffset;
		while (k < (NameOffset + 3*NameLength)) {
			AuxVar0 = (document.Organizer.syxout.value).substr(k, 2);
			AuxVar0 = parseInt(AuxVar0, 16);
			if ((InstrOS == 2)||(InstrOS == 3)||(InstrOS == 4)||(InstrOS == 5)) {
				AuxName += String.fromCharCode(NameChrs[AuxVar0]);
			} else {
				AuxName += String.fromCharCode(AuxVar0);
			}
			k +=3;
		}
		document.Organizer.nameout.value = AuxName;
	}
}

function BtnHelp() {
	OrgHelp = window.open("org_help.html" ,'OrgHelp' ,'width=600,height=640,scrollbars=yes,location=no,left=20,top=20,menubar=no,resizable=yes,toolbar=no,status=no');
	if (OrgHelp) OrgHelp.focus();
}

function GetOptions() {
	var i
	for (i=0; i<=TonesNr; ++i) {
		document.write("<option value=");
		document.write(i);
		document.write(">");
		document.write(i+1);
		document.write("</option>");
	}
}

function GetOptA() {
	var i
	for (i=0; i<=(TonesNr/128); ++i) {
		document.write("<option value=");
		document.write(i);
		document.write(">");
		document.write(i);
		document.write("</option>");
	}
}

function GetOptB() {
	var i
	for (i=0; i<=(TonesNr/128); ++i) {
		document.write("<option value=");
		document.write(i);
		if (i==1 && ErrorCheck==9) {
			document.write(" selected");
		} 
		document.write(">");
		document.write(i);
		document.write("</option>");
	}
}

function GetName() {
	document.write("<input name='nameout' type='text' style='width:110px;font-size:11px;' value='");
	var i
	var AuxName = ""
	for (i=0; i<NameLength; ++i) {
		AuxName += " "
	}
	document.write(AuxName);
	document.write("' onChange='ChangeName();'>");
}

// INDEX //
function WriteIndex() {
	var i;
	document.write("<center><table border='4' cellpadding='1' cellspacing='1' bordercolor='#999999' bgcolor='#cccc99'>");
	document.write("<tr><td><table border='0' cellpadding='0' cellspacing='3'>");
	document.write("<tr><td colspan='4' align='center' class='headtxt'><img src='data/media/logo.gif' width='65' height='14' border='0' alt='CHD Elektroservis'>&nbsp;&nbsp;&nbsp;Tone Memory Organizer<br>Instrument Index Table</td></tr>\n");
	document.write("<tr><td colspan='4' class='normtxt'><hr size='3'></td></tr>\n");
	document.write("<tr class='normtxt'><td align='left' width='60pix'>Producer:</td>");
	document.write("<td align='left' width='200pix'>Instrument:</td>");
	document.write("<td align='left' width='60pix'>OS / ver. Nr.:</td>");
	document.write("<td align='right' width='40pix'>Open:</td></tr>\n");
	document.write("<tr><td colspan='4' class='normtxt'><hr size='1'></td></tr>\n");
	for (i=1; i<=(IndexTab.length-1); ++i) {
		if (IndexTab[i][0] != "???") {
			document.write("<tr class='boldtxt'><td align='left'>");
			document.write(IndexTab[i][0]);
			document.write("</td><td align='left'>");
			document.write(IndexTab[i][1]);
			document.write("</td><td align='left'>OS ");
			document.write(IndexTab[i][2]);
			document.write(" / ");
			document.write(IndexTab[i][3]);
			document.write("</td><td align='right'><a href='data/");
			document.write(IndexTab[i][4]);
			document.write("_org.html' target='_self' title='Open'>");
			document.write("<img src='data/media/btnopenoff.gif' onmouseover=\"this.src = 'data/media/btnopenon.gif'\" onmouseout=\"this.src = 'data/media/btnopenoff.gif'\"></a></td></tr>\n");
		}
	}
	document.write("<tr><td colspan='4' class='normtxt'><hr size='3'></td></tr>\n");
	document.write("<tr class='normtxt'><td colspan='4' align='center'>Rev.: ");
	document.write(IdxRev);
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;Updated: ");
	document.write(IdxUpd);
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;&copy; <a href='https://www.chd-el.cz/products/savvy/' target='_blank' title='SAVVY on CHD web pages'>CHD Elektroservis</a></td></tr>\n");
	document.write("</table></td></tr>");
	document.write("</table></center>");
}

// ORGANIZER //
function WriteTable() {
	document.write("<center><table border='0' cellpadding='0' cellspacing='0'>");
	document.write("<tr><td><table border='0' cellpadding='0' cellspacing='3'>");
	document.write("<tr><td align='left' bgcolor='#d8d8d8'>");
	document.write("<table border='3' cellpadding='1' cellspacing='1' bordercolor='#999999' bgcolor='#cccc99'><tr><td>");
	document.write("<table border='0' cellpadding='0' cellspacing='3' bgcolor='#cccc99'>");
	document.write("<tr><td colspan='5' align='center' class='headtxt'><img src='media/logo.gif' width='65' height='14' border='0' alt='CHD Elektroservis'>&nbsp;&nbsp;&nbsp;Tone Memory Organizer for<br>");
	document.write(IndexTab[InstrOS][0]);
	document.write("&nbsp;");
	document.write(IndexTab[InstrOS][1]);
	document.write("</td></tr>\n<tr class='nonetxt'><td colspan='5'><hr size='3'></td></tr>\n");
	document.write("<tr><td colspan='5' align='center' class='boldtxt'>Complete memory content Bulk Dump stream:</td></tr>\n");
	document.write("<tr><td colspan='5' align='center'><table border='2' cellpadding='0' cellspacing='0' bordercolor='#999999'>");
	document.write("<tr><td colspan='5' align='center'><textarea name='wholemsg' style='width:468px;height:80px;font-size:11px;'></textarea></td></tr></table></td></tr>\n");
	document.write("<tr class='normtxt'><td colspan='5' align='center'><img src='media/btnchckoff.gif' onmouseover=\"this.src = 'media/btnchckon.gif'\" onmouseout=\"this.src = 'media/btnchckoff.gif'\" onmousedown=\"this.src = 'media/btnchckdn.gif'\" onmouseup=\"this.src = 'media/btnchckon.gif'\" onClick='CheckData()'></td></tr>\n");
	document.write("<tr class='normtxt'><td colspan='2' align='center'>Device ID:&nbsp;<input name='statusid' type='text' ReadOnly style='width:25px;font-size:11px;' value=''></td>");
 	document.write("<td colspan='3' align='center'>Status:&nbsp;<input name='statuscheck' type='text' ReadOnly size='55' style='font-size:11px;' value=''></td></tr>\n");
	document.write("<tr class='nonetxt'><td colspan='5'><hr size='1'></td></tr>\n");
	document.write("<tr><td colspan='5' align='left' class='brntxt'>Single Tone Processing</td></tr>\n"); 
	document.write("<tr><td align='center'><img src='media/btndecoff.gif' onmouseover=\"this.src = 'media/btndecon.gif'\" onmouseout=\"this.src = 'media/btndecoff.gif'\" onClick='InDec()'>");
	document.write("<img src='media/btnincoff.gif' onmouseover=\"this.src = 'media/btnincon.gif'\" onmouseout=\"this.src = 'media/btnincoff.gif'\" onClick='InInc()'></td>");
	document.write("<td colspan='4' align='center' valign='top' class='boldtxt'>Source Tone Data:</td></tr>\n");
	document.write("<tr><td align='center' class='redtxt'>Tone Nr.</td><td align='center' class='normtxt'>(Bank Nr.)</td><td align='center' class='normtxt'>(Pgm Nr.)</td><td align='center' class='normtxt'>(Name)</td><td align='center' class='normtxt'>(Bulk Dump SysEx Data)</td></tr>\n");
	document.write("<tr class='normtxt'><td align='center'><select name='tonein' type='selectbox' value='0' style='width:44px;font-size:11px;' onchange='GetIn()'>");
	GetOptions()
	document.write("</select></td><td align='center'><input name='bankin' type='text' ReadOnly style='width:44px;font-size:11px;' value='0'></td><td align='center'><input name='pgmin' type='text' ReadOnly style='width:44px;font-size:11px;' value='0'></td><td align='center'><input name='namein' type='text' ReadOnly style='width:110px;font-size:11px;' value=''></td><td align='center'><input name='syxin' type='text' ReadOnly style='width:222px;font-size:11px;' value=''></td></tr>\n");
	document.write("<tr><td colspan='5' class='normtxt'>&nbsp;</td></tr>\n");
	document.write("<tr><td align='center'><img src='media/btndecoff.gif' onmouseover=\"this.src = 'media/btndecon.gif'\" onmouseout=\"this.src = 'media/btndecoff.gif'\" onClick='OutDec()'>");
	document.write("<img src='media/btnincoff.gif' onmouseover=\"this.src = 'media/btnincon.gif'\" onmouseout=\"this.src = 'media/btnincoff.gif'\" onClick='OutInc()'></td>");
	document.write("<td colspan='4' align='center' valign='top' class='boldtxt'>Target Tone Data:</td></tr>\n");
	document.write("<tr><td align='center' class='redtxt'>Tone Nr.</td><td align='center' class='normtxt'>(Bank Nr.)</td><td align='center' class='normtxt'>(Pgm Nr.)</td><td align='center' class='redtxt'>Write New Name</a></td><td align='center' class='normtxt'>(Bulk Dump SysEx Data)</td></tr>\n");
	document.write("<tr class='normtxt'><td align='center'><select name='toneout' type='selectbox' value='0' style='width:44px;font-size:11px;' onchange='GetOut()'>");
	GetOptions()
	document.write("</select></td><td align='center'><input name='bankout' type='text' ReadOnly style='width:44px;font-size:11px;' value='0'></td><td align='center'><input name='pgmout' type='text' ReadOnly style='width:44px;font-size:11px;' value='0'></td><td align='center'>");
	GetName()
	document.write("</td><td align='center'><input name='syxout' type='text' ReadOnly style='width:222px;font-size:11px;' value=''></td></tr>\n");
	document.write("<tr class='normtxt'><td colspan='5'>&nbsp;</td></tr>\n");
	document.write("<tr><td colspan='5' align='center'><img src='media/btnnameoff.gif' onmouseover=\"this.src = 'media/btnnameon.gif'\" onmouseout=\"this.src = 'media/btnnameoff.gif'\" onClick='CopyName()'>");
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;<img src='media/btninisoff.gif' onmouseover=\"this.src = 'media/btninison.gif'\" onmouseout=\"this.src = 'media/btninisoff.gif'\" onClick='InitOut()'>");
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;<img src='media/btnsaveoff.gif' onmouseover=\"this.src = 'media/btnsaveon.gif'\" onmouseout=\"this.src = 'media/btnsaveoff.gif'\" onClick='SaveOut()'></td></tr>\n"); 
	document.write("<tr class='nonetxt'><td colspan='5'><hr size='1'></td></tr>\n");
	document.write("<tr><td colspan='5' align='left' class='brntxt'>Whole Bank Processing</td></tr>\n");
	document.write("<tr><td align='center'><img src='media/btndecoff.gif' onmouseover=\"this.src = 'media/btndecon.gif'\" onmouseout=\"this.src = 'media/btndecoff.gif'\" onClick='BADec()'>");
	document.write("<img src='media/btnincoff.gif' onmouseover=\"this.src = 'media/btnincon.gif'\" onmouseout=\"this.src = 'media/btnincoff.gif'\" onClick='BAInc()'></td>");
	document.write("<td align='center'><img src='media/btndecoff.gif' onmouseover=\"this.src = 'media/btndecon.gif'\" onmouseout=\"this.src = 'media/btndecoff.gif'\" onClick='BBDec()'>");
	document.write("<img src='media/btnincoff.gif' onmouseover=\"this.src = 'media/btnincon.gif'\" onmouseout=\"this.src = 'media/btnincoff.gif'\" onClick='BBInc()'></td>");
	document.write("<td colspan='3' align='center' valign='top' class='boldtxt'>Execute:</td></tr>\n");
	document.write("<tr><td align='center' class='redtxt'>Bank A</td><td align='center' class='redtxt'>Bank B</td>");
	document.write("<td colspan='3'></td></tr>\n");
	document.write("<tr class='normtxt'><td align='center'><select name='bain' type='selectbox' value='0' style='width:44px;font-size:11px;' onchange='GetBA()'>");
	GetOptA()
	document.write("</select></td><td align='center'><select name='bbin' type='selectbox' value='1' style='width:44px;font-size:11px;' onchange='GetBB()'>");
	GetOptB()
	document.write("</select></td>");
	document.write("<td colspan='3' align='center'>");
	document.write("<img src='media/btncopyoff.gif' onmouseover=\"this.src = 'media/btncopyon.gif'\" onmouseout=\"this.src = 'media/btncopyoff.gif'\" onClick='CopyB()'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	document.write("<img src='media/btnexchoff.gif' onmouseover=\"this.src = 'media/btnexchon.gif'\" onmouseout=\"this.src = 'media/btnexchoff.gif'\" onClick='ExchB()'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	document.write("<img src='media/btniniboff.gif' onmouseover=\"this.src = 'media/btninibon.gif'\" onmouseout=\"this.src = 'media/btniniboff.gif'\" onClick='InitB()'>"); 
	document.write("</td></tr>\n");
	document.write("<tr class='nonetxt'><td colspan='5'><hr size='3'></td></tr>\n");
	document.write("<tr class='normtxt'><td align='left'><a href='' onclick='document.Organizer.reset(); return false' title='Reset all data'>Reset</a></td>");
	document.write("<td align='left'><a href='../index.html' target='_self' title='Back to Index window' onClick='OrgHelp.close();'>Index</a></td>");
	document.write("<td align='left'>");
	document.write("<a href='' onclick='BtnHelp(); return false' title='Open help window'>Help</a></td>");
	document.write("<td colspan='2' align='right'>OS ");
	document.write(IndexTab[InstrOS][2]);
	document.write(" ver. ");
	document.write(IndexTab[InstrOS][3]);
	document.write(" - ");
	document.write(UpDate);
	document.write("&nbsp;&nbsp;&nbsp;&copy; ");
	document.write(" <a href='https://www.chd-el.cz/products/savvy/' target='_blank' title='SAVVY on CHD web pages'>CHD Elektroservis</a></td></tr>\n");
	document.write("</table></td></tr>\n");
	document.write("</table></td></tr>\n");
	var i, j, k, ToneView;
	var TabCls0 = (Math.floor(TonesNr / 128));
	var TabCls1 = TabCls0 + 1;
	document.write("<tr><td align='left' bgcolor='#d8d8d8'>");
	document.write("<table border='3' cellpadding='1' cellspacing='1' bordercolor='#999999' bgcolor='#cccc99'><tr><td>");
	document.write("<table border='0' cellpadding='0' cellspacing='3'>");
	document.write("<tr><td colspan='");
	document.write(TabCls1);
	document.write("' align='center' class='headtxt'>Complete Tone Library</td></tr><tr class='nonetxt'><td colspan='");
	document.write(TabCls1);
	document.write("'><hr size='3'></td></tr>");
	document.write("<tr class='boldtxt'>");
	for (i=0; i<=TabCls0; ++i) {
		document.write("<td align='center'>Bank ");
		document.write(i);
		document.write("</td>");
	}
	document.write("</tr>\n");

	document.write("<tr class='nonetxt'>");
	for (i=0; i<=TabCls0; ++i) {
		document.write("<td align='center'><hr size='1'></td>");
	}
	document.write("</tr>\n");

	document.write("<tr class='normtxt'>");
	for (i=0; i<TabCls1; ++i) {
		document.write("<td align='left'>Tone&nbsp;&nbsp;:&nbsp;&nbsp;&nbsp;Name</td>");
	}
	document.write("</tr>\n");
	document.write("<tr>");
	for (i=0; i<=TabCls0; ++i) {
		document.write("<td><textarea name='");
		ToneView = "tonevw";
		ToneView += i;
		document.write(ToneView);
		document.write("' rows='128' cols='");
		ToneView = NameLength + 4;
		document.write(ToneView);
		document.write("' style='font-size:11px;' ReadOnly>");
		ToneView = "";
		for (j=0; j<128; ++j) {
			k = 128*i+j+1+":           \n";
                        while (k.length < 16) {
				k = "0" + k;
			}
			ToneView += k;
		}
		document.write(ToneView);

		document.write("</textarea></td>");
	}
	document.write("</tr>\n");
	document.write("</table></td></tr>\n");
	document.write("</table></td></tr>\n");
	document.write("</table></center>");
}

// HELP //
function WriteHelp() {
	document.write("<p align='center' class='headtxt'><nobr><img src='media/logoh.gif' width='65' height='14' border='0' alt='CHD Elektroservis'>&nbsp;nbsp;&nbsp;Tone Memory Organizer</nobr><br>Help</p>\n");
	document.write("<p class='normtxt'><hr size='1'></p><p align='center'>This utility enables to rename, to relocate and to initialize the tones in SAVVY\'s memory. You can change single tone or more tones at once. Also whole tone banks can be copied, exchanged or initialized.</p><p class='normtxt'><hr size='1'></p>\n");
	document.write("<p align='center' class='boldtxt'>How to use</p>\n");
	document.write("<p align='justify' class='brntxt'>Data Loading:</p><ol>\n");
	document.write("<li>Connect SAVVY to your PC/DAW with both MIDI-IN and MIDI-OUT cables and prepare the PC/DAW for SysEx data recording.</li>\n");
	document.write("<li>Press the <b>SLCTC</b> button on SAVVY so that yellow <b>INST->CTRL</b> LED lights.</li>\n");
	document.write("<li>Press the <b>DUMP</b> button on SAVVY and record transmitted stream of SysEx messages in the PC/DAW.</li>\n");
	document.write("<li>Open the recorded data <b>as a text</b> (F0...F7 F0...F7 ... F0...F7).</li>\n");
	document.write("<li>Copy the recorded data (e.g. with help of clipboard) to the <b>Complete memory content Bulk Dump stream</b> text field in upper section of the organizer table.</li>\n");
	document.write("<li>Click the <b>Check Data</b> button</li>\</ol>\n");
	document.write("<p align='justify' class='brntxt'>Single Tone Processing:</p><ol>\n");
	document.write("<li>Select the tone to be edited in <b>Source Tone Data</b> section of the organizer table (<b>Tone Nr.</b> select-box or <b>-</b>/<b>+</b> buttons - see remarks below).</li>\n");
	document.write("<li>Name and SysEx data of the selected tone are shown in the <b>(Name)</b> and the <b>(SysEx Data)</b> text fields.</li>\n");
	document.write("<li>Select new requested location (number) of the edited tone in <b>Target Tone Data</b> section of the organizer table (<b>Tone Nr.</b> select-box or <b>-</b>/<b>+</b> buttons - see remarks below).<br>\n");
	document.write("If you do not want to move the edited tone but only to rename it, select the same tone number in <b>Target Tone Data</b> section as the number of edited tone in <b>Source Tone Data</b> section.</li>\n");
	document.write("<li>Write new name of the edited tone to the <b>Write New Name</b> text box and press Enter on the PC keyboard (see remarks below).<br>\n");
	document.write("If you do not want to rename the edited tone but only to move it, click the <b>Copy Name</b> button - the original name of edited tone will be used.</li>\n");
	document.write("<li>The new name and SysEx data of the changed tone are shown in the <b>Write New Name</b> and the <b>(SysEx Data)</b> text boxes.</li>\n");
	document.write("<li>Click the <b>Save Changes</b> button </li>\n");
	document.write("<li>The changed data are written to the the original stream of SysEx messages. The <b>Complete Tone Library</b> table with all tone names is also actualized.</li>\n");
	document.write("<li>Repeat any single tone or whole bank procedure while all required tones / banks are not processed.</li></ol>\n");
	document.write("<p align='justify' class='brntxt'>Whole Bank Processing:</p><ol>\n");
	document.write("<li>Select the source bank number in the <b>Whole Bank Processing</b> section of the organizer table (<b>Bank A</b> select-box or <b>-</b>/<b>+</b> buttons).</li>\n");
	document.write("<li>Select the target bank number in the <b>Whole Bank Processing</b> section of the organizer table (<b>Bank B</b> select-box or <b>-</b>/<b>+</b> buttons).<br>\n");
	document.write("Bank B need not be chosen for the <b>Initialize</b> function.</li>\n");
	document.write("<li>Click the <b>Copy A to B</b> or <b>Exchange A with B</b> or <b>Initialize A</b> button in dependence what you want to do:\n");
	document.write("<ul><li>Content of the source bank A is copied to the target bank B and the source bank A remains unchanged for the <b>Copy</b> function.</li>\n");
	document.write("<li>Original content of the bank A is written to the bank B and original content of the bank B is written to the bank A for the <b>Exchange</b> function.</li>\n");
	document.write("<li>Content of the bank A is replaced with initialization data - the same default tone is loaded into all positions of the bank for the <b>Initialize</b> function.</li></ul></li>\n");
	document.write("<li>The changed data are written to the the original stream of SysEx messages. The <b>Complete Tone Library</b> table with all tone names is also actualized.</li>\n");
	document.write("<li>Repeat any single tone or whole bank procedure while all required tones / banks are not processed.</li></ol>\n");
	document.write("<p align='justify' class='brntxt'>Data Saving:</p><ol>\n");
	document.write("<li>Connect SAVVY to your PC/DAW with both MIDI-IN and MIDI-OUT cables and prepare the PC/DAW for SysEx data transmitting.</li>\n");
	document.write("<li>Copy the <b>Complete memory content Bulk Dump stream</b> text field in upper section of the organizer table (e.g. with help of clipboard) to the SysEx editor of your PC/DAW.</li>\n");
	document.write("<li>Press the <b>SLCTC</b> button on SAVVY so that green <b>CTRL->INST</b> LED lights.</li>\n");
	document.write("<li>Send the SysEx data from the PC/DAW to SAVVY.</li></ol>\n");
	document.write("<p class='normtxt'><hr size='1'></p><p align='center'><b>Links in bottom row of the organizer table</b></p>\n");
	document.write("<p align='justify'><b>Reset</b> - clears all fields in the organizer window.<br><b>Index</b> - closes the Organizer window and returns to instrument selection table.<br><b>Help</b> - opens this help window.</p>\n");
	document.write("<p class='normtxt'><hr size='1'></p><p align='center'><b>Remarks</b></p>\n");
	document.write("<p align='justify' class='brntxt'><b>Tone Number Format:</b></p><ul>\n");
	document.write("<li>The tones are always numbered from <b>1</b> independently on setting of the <b>Tone Number Format</b> global parameter.</li></ul>\n");
	document.write("<p align='justify' class='brntxt'><b>Tone Name:</b></p><ul>\n");
	document.write("<li>Length of the name is limited by the instrument possiblities. Longer text will be shorten.</li>\n");
	document.write("<li>Character set of the name is limited by the instrument possiblities. Unknown characters will be replaced with <b>space</b>.</li></ul>\n");
	document.write("<p class='normtxt'><hr size='1'></p><p align='center' class='normtxt'>&copy; CHD Elektroservis</p>");
}
